<script>
	import Saos from 'saos';
	import Streamer from '@/components/streamer.svelte';
	import back from '@/plugins/axios.js';
	import { socketStore } from '@/plugins/socket.js';
	import { topics } from '@/plugins/store.js';
	import { writable } from 'svelte/store';
	import { onMount, onDestroy } from 'svelte';
	import { page } from '$app/stores';
	let streamers = [];
	let sortedIndices = [];
	let init;
	let mainStreamId = import.meta.env.VITE_MAIN_STREAM_ID;
	let mainStreamIndex = undefined;
	let teamId = undefined;

	onMount(async () => {
		let t = $page.url.searchParams.get('team');

		if (t != null && !isNaN(Number(t))) {
			teamId = Number(t);
		}

		try {
			let response = await back.get('/streamers/');
			streamers = response.data;
			// Odd or even is used to not have a uniform grid
			for (let i = 0; i < streamers.length; i++) {
				streamers[i].odd = i % 2;
				streamers[i].data = writable({ view_count: 0, is_live: false });

				// Update the main stream index
				if (streamers[i].id == mainStreamId) {
					mainStreamIndex = i;
				}

				sortedIndices.push(i);
			}
			if (!init) {
				return;
			}
			for (let i = 0; i < init.length; i++) {
				if (!init[i].topic.includes('/streamers/')) {
					continue;
				}
				for (let j = 0; j < streamers.length; j++) {
					if (streamers[j].id != init[i].topic.split('/')[2]) {
						continue;
					}
					if (!streamers[j].data) {
						// Create a store for the streamer data
						streamers[j].data = writable({ view_count: 0, is_live: false });
						streamers[j].vc = 0;
						streamers[j].il = false;
					} else {
						// Update the store
						streamers[j].data.update((str) => {
							str.view_count = init[i].message.view_count;
							str.is_live = init[i].message.is_live;
							return str;
						});
						streamers[j].vc = init[i].message.view_count;
						streamers[j].il = init[i].message.is_live;
					}
					// streamers[j].view_count = messages[i].message.view_count;
					// streamers[j].is_live = messages[i].message.is_live;
				}
			}
		} catch (e) {
			console.log(e);
		} finally {
			topics.sub(topic);
		}
	});

	let topic = 'streamers.*.live';
	let unsubscribe;
	$: {
		if (!unsubscribe) {
			socketStore.update((store) => {
				unsubscribe = store.subscribe((message) => {
					// Do something with the message here
					try {
						let m = JSON.parse(message);

						if ('op' in m || !m.r.match('streamers\\.\\d+\\.live')) {
							return;
						}

						for (let j = 0; j < streamers.length; j++) {
							if (streamers[j].id != m.d.streamerID) {
								continue;
							}
							if (!streamers[j].data) {
								streamers[j].data = writable({ view_count: 0, is_live: false });
								streamers[j].vc = 0;
								streamers[j].il = false;
							}

							// Update the store
							streamers[j].data.update((str) => {
								str.view_count = m.d.viewCount;
								str.is_live = m.d.isLive;
								return str;
							});
							streamers[j].vc = m.d.viewCount;
							streamers[j].il = m.d.isLive;
						}
					} catch (e) {
						console.log(e);
					}

					sortStreamers(mainStreamIndex);
				});
				return store;
			});
		}
	}

	onDestroy(() => {
		unsubscribe();
		// Remove the topic from the socket
		topics.unsub(topic);

		unsubscribe = null;
	});

	function sortStreamers(prio) {
		let temp = [];
		for (let i = 0; i < streamers.length; i++) {
			if (i == prio) {
				continue;
			}

			// Filter streamer by team if necessary
			if (teamId != undefined && streamers[i].team_id != teamId) {
				continue;
			}

			// insert the streamer at the correct position
			let inserted = false;
			for (let j = 0; j < temp.length; j++) {
				if (streamers[i].vc > streamers[temp[j]].vc) {
					temp.splice(j, 0, i);
					inserted = true;
					break;
				}
			}
			if (!inserted) {
				temp.push(i);
			}
			
		}
		// temp.sort((a, b) => {
		// 	return streamers[a].vc ?? 0 - streamers[b].vc ?? 0;
		// });

		//if (prio != undefined) temp = [prio, ...temp];

		sortedIndices = temp;

	}
</script>

<div class="w-full justify-center justify-items-center">
	{#if mainStreamIndex && teamId == undefined}
		<div class="animated grid justify-center justify-items-center mt-10">
			<Saos once={true} animation="from-bottom .25s cubic-bezier(.25,.46,.45,.94) both">
				<Streamer streamer={streamers[mainStreamIndex]} />
			</Saos>
		</div>
	{/if}
	<div class="animated grid xl:grid-cols-3 md:grid-cols-2 justify-center justify-items-center">
		{#each sortedIndices as streamer_i, i}
			{#if i % 2 == 0}
				<div class="mt-10 mb-10">
					<Saos once={true} animation="from-left .25s cubic-bezier(.25,.46,.45,.94) both">
						<Streamer streamer={streamers[streamer_i]} />
					</Saos>
				</div>
			{:else}
				<div class="mt-10 mb-10 md:pt-28">
					<Saos once={true} animation="from-right .25s cubic-bezier(.25,.46,.45,.94) both">
						<Streamer streamer={streamers[streamer_i]} />
					</Saos>
				</div>
			{/if}
		{/each}
	</div>
</div>

<style>
	@media (min-width: 500px) {
		@keyframes -global-from-left {
			0% {
				transform: rotateX(50deg) translateX(-200vw) skewX(-50deg);
				opacity: 1;
			}
			100% {
				transform: rotateX(0deg) translateX(0) skewX(0deg);
				opacity: 1;
			}
		}

		@keyframes -global-from-right {
			0% {
				transform: rotateX(50deg) translateX(200vw) skewX(50deg);
				opacity: 1;
			}
			100% {
				transform: rotateX(0deg) translateX(0) skewX(0deg);
				opacity: 1;
			}
		}
	}
</style>
